// Description: 
// By Sarah Dean
// Email: sdean12@sdean12.org
// WWW:   http://www.FreeOTFE.org/
//
// -----------------------------------------------------------------------------
//


#ifndef _FreeOTFElib_H
#define _FreeOTFElib_H   1


#include <ntddk.h>
#include <stdio.h>

// Required for std disk device driver I/O control (IOCTL) codes
#include <ntdddisk.h>

#include <initguid.h>  // Required for DEFINE_GUID macro

// =========================================================================
// Const definitions

DEFINE_GUID(NULL_GUID,  0x00000000L, 0x0000, 0x0000, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00);


// =========================================================================
// Function headers


// Create device dir
NTSTATUS
CreateDeviceDir(
    IN   PWCHAR DirName,
    OUT  PHANDLE DirHandle
);


// Length of the string representation of a GUID, in bytes
// WARNING: This omits any NULL terminator
#define GUID_STRING_REP_CHAR_LENGTH  strlen("{zzzzzzzz-zzzz-zzzz-zzzz-zzzzzzzzzzzz}")

// Length of the string representation of a GUID, in *bytes*
// WARNING: This omits any NULL terminator
#define GUID_STRING_REP_UNICODE_BYTE_LENGTH  (GUID_STRING_REP_CHAR_LENGTH * sizeof(WCHAR))


NTSTATUS
AppendGUIDToUnicodeString(
    IN      GUID  useGUID,
    IN OUT  PUNICODE_STRING unicodeString
);

    
// Convert the data passed in to it's ASCIIZ representation
// Note: outASCIIKey *must* be at least ((inKeyLength/4)+1) bytes long to store the ASCIIZ
//       representation of the key, including the terminating NULL
NTSTATUS ConvertDataToASCIIRep(
  unsigned int inKeyLength, // in Bits
  unsigned char* inKeyData,
  char* outASCIIKey
);


// Convert the specified nibble into a ASCII hex char
char _ConvertDataNibbleToASCIIChar(unsigned int nibble);


// Overwrite and zero memory
void SecZeroMemory(
    IN void          *Memory,
    IN unsigned int  Size
);


// XOR block of memory
void XORBlock(
    IN   unsigned char*  InA,
    IN   unsigned char*  InB,
    OUT  unsigned char*  Out,
    IN   unsigned int    Size  // In Bytes
);


// =========================================================================
// =========================================================================

#endif

